﻿Imports System.Collections.ObjectModel

Public Class Form1

    Dim YY As Integer = 0
    Dim FESize As Size = New Size(15, 15)

    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click
        Me.clsDrawingPanel1.colObjects.Clear()
        YY = 10
        For i = 1 To 12
            Dim nDO As New clsDrawingObjectFE(Me.clsDrawingPanel1)
            With nDO
                .Bounds = New Rectangle(0, YY, FESize.Width, FESize.Height)
                .Location = New Point(5, .Bounds.Y)
                .OldLocation = .Location
                .Name = "Links: " & i.ToString
                YY += CInt(FESize.Height * 1.5)
                Me.clsDrawingPanel1.colObjects.Add(nDO)
            End With
        Next
        YY = 10
        For i = 1 To 12
            Dim nDO As New clsDrawingObjectFE(Me.clsDrawingPanel1)
            With nDO
                .Bounds = New Rectangle(0, YY, FESize.Width, FESize.Height)
                .Location = New Point(200, .Bounds.Y)
                .OldLocation = .Location
                .Name = "Rechts: " & i.ToString
                YY += CInt(FESize.Height * 1.5)
                Me.clsDrawingPanel1.colObjects.Add(nDO)
            End With
        Next
        Me.clsDrawingPanel1.Invalidate()
    End Sub

    Private Sub clsDrawingPanel1_eventHighlightedObjectChanged(HighlightedFE As clsDrawingObject) Handles clsDrawingPanel1.eventHighlightedObjectChanged
        If Not HighlightedFE Is Nothing Then
            Me.TextBox3.Text = HighlightedFE.Name
        Else
            Me.TextBox3.Text = ""
        End If
        RefreshLV()
    End Sub

    Private Sub clsDrawingPanel1_eventHoveredObjectChanged(HoveredFE As clsDrawingObject) Handles clsDrawingPanel1.eventHoveredObjectChanged
        If Not HoveredFE Is Nothing Then
            Me.TextBox2.Text = HoveredFE.Name
        Else
            Me.TextBox2.Text = ""
        End If
        RefreshLV()
    End Sub

    Private Sub clsDrawingPanel1_eventSelectedObjectChanged(SelectedFE As clsDrawingObject) Handles clsDrawingPanel1.eventSelectedObjectChanged
        If Not SelectedFE Is Nothing Then
            Me.TextBox1.Text = SelectedFE.Name
        Else
            Me.TextBox1.Text = ""
        End If
        RefreshLV()
    End Sub

    Private Sub clsDrawingPanel1_eventObjectListChanged(sender As Object, e As System.Collections.Specialized.NotifyCollectionChangedEventArgs) Handles clsDrawingPanel1.eventObjectListChanged
        Me.Label1.Text = clsDrawingPanel1.colObjects.Count.ToString
        clsDrawingPanel1.RealPaint()
        Me.ListView1.BeginUpdate()
        Me.ListView1.Items.Clear()
        For Each cDO In Me.clsDrawingPanel1.colObjects
            Dim nLV As ListViewItem = Me.ListView1.Items.Add(cDO.Name)
            If Not cDO.ConnectedTo Is Nothing Then
                nLV.SubItems.Add(cDO.ConnectedTo.Name)
            Else
                nLV.SubItems.Add("")
            End If
        Next
        Me.ListView1.EndUpdate()
    End Sub

    Private Sub Form1_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        AddHandler clsDrawingPanel1.colObjects.CollectionChanged, AddressOf clsDrawingPanel1_eventObjectListChanged
    End Sub

    Private Sub RefreshLV()
        'Me.ListView1.BeginUpdate()
        For Each cDO In Me.clsDrawingPanel1.colObjects
            For Each LV As ListViewItem In Me.ListView1.Items
                If LV.Text = cDO.Name Then
                    If Not cDO.ConnectedTo Is Nothing Then
                        If LV.SubItems(1).Text <> cDO.ConnectedTo.Name Then
                            LV.SubItems(1).Text = cDO.ConnectedTo.Name
                        End If

                        If cDO.ConnectedTo.isSelected Then
                            LV.SubItems(1).ForeColor = Color.YellowGreen
                        ElseIf cDO.ConnectedTo.isHovered Then
                            LV.SubItems(1).ForeColor = Color.YellowGreen
                        ElseIf cDO.ConnectedTo.isHighlighted Then
                            LV.SubItems(1).ForeColor = Color.YellowGreen
                        Else
                            LV.SubItems(1).ForeColor = Color.Black
                        End If
                    Else
                        LV.SubItems(1).Text = ""
                    End If

                    If cDO.isSelected Then
                        LV.ForeColor = Color.YellowGreen
                    ElseIf cDO.isHovered Then
                        LV.ForeColor = Color.YellowGreen
                    ElseIf cDO.isHighlighted Then
                        LV.ForeColor = Color.YellowGreen
                    Else
                        LV.ForeColor = Color.Black
                    End If

                End If

                'Dim nLV As ListViewItem = Me.ListView1.Items.Add(cDO.Name)
                'If Not cDO.ConnectedTo Is Nothing Then
                '    nLV.SubItems.Add(cDO.ConnectedTo.Name)
                'Else
                '    nLV.SubItems.Add("")
                'End If
            Next
        Next
        'Me.ListView1.EndUpdate()
    End Sub

End Class
